@echo off
:: Author - Peter Lovell - Batpower 4/1/96
    echo.
    if "%1"=="" goto Instruct
    ver>ms-dot.bat
    echo set ver=%%2>ms-dos.bat
    call ms-dot.bat
    if "%ver%"=="" goto Error
    echo MS-DOS Version %ver% detected
    echo @prompt debug command.new $l ms-dos.bat $g nul>ms-dos.bat
    %comspec%/e:2048/c ms-dos.bat>ms-dot.bat

:: remove any attributes from command.com, just in case.
    attrib %comspec% -r -s -h

    copy %comspec% command.new>nul
    copy %comspec% command.old>nul

:Test_62_
    if not %ver%==6.22 if not %ver%==6.20 goto Test_600
    echo e 1777 %1>ms-dos.bat
    goto Patch_It

:Test_600
    if not %ver%==6.00 goto Test_500
    echo e 1767 %1>ms-dos.bat
    goto Patch_It

:Test_500
    if not %ver%==5.00 goto Test_401
    echo e 1666 %1>ms-dos.bat
    goto Patch_It

:Test_401
    if not %ver%==5.00 goto Test_330
    echo e 1c2a %1>ms-dos.bat
    goto Patch_It

:Test_330
    if not %ver%==3.30 goto Error
    echo e eb8 %1>ms-dos.bat
    goto Patch_It

:Patch_It
    echo w>>ms-dos.bat
    echo q>>ms-dos.bat
    call ms-dot.bat
    copy command.new %comspec%>nul
    del command.new
    echo %comspec% has been patched as specified by %%1=%1
    echo.
    fc/b command.old %comspec%
    echo COMMAND.OLD lives in the current directory.
    goto Exit

:Instruct
    echo.
    echo. Patch %comspec% to alter the default environment size:
    echo.
    echo.               Various environment size values:
    echo.
    echo.           01 =   16 bytes           40 = 1024 bytes
    echo.           10 =  256 bytes           60 = 1536 bytes
    echo.           20 =  512 bytes           80 = 2048 bytes
    echo.           30 =  768 bytes           FF = 4080 bytes
    echo.
    echo.  Command syntax is:
    echo.
    echo.       %0 new_environment_size_in_hex
    echo.
    echo.  eg.  %0 40
    echo.
    echo.       will patch %comspec% to have a default
    echo.       environment size of 1024 bytes
    echo.
    goto Exit

:Error
    echo 
    if "%ver%"=="" echo Unable to detect MS-DOS Version
    if not "%ver%"=="" echo Unable to patch MS-DOS Version %ver%

:Exit
    for %%a in (t s) do if exist ms-do%%a.bat del ms-do%%a.bat
    echo.
